var Pkg = xdc.module("xdc.bld.PackageContents");

/*
 *  ======== archive ========
 */
function archive(container, lib, objList, archArgs, res)
{
//    print("archive filter ...");
//    print("    container: " + container);
//    print("    lib      : " + lib.name);
//    print("    files    : " + objList);

    /* replace archive command with one that uses the arguments in a file */
    res.cmds = mkCommandFile(container, res.cmds);
}

/*
 *  ======== mkCommandFile ========
 */
function mkCommandFile(archiveName, command)
{
    /* split original ar command on each space boundry */
    var tokens = command.split(/\s+/);

    /* create new ar command to put in makefile */
    var cmd = tokens.shift() + " -@" + archiveName + ".cmd";

    /* create a command file to hold ar's command line options */
    var file = new java.io.BufferedWriter(
        new java.io.FileWriter(archiveName + ".cmd"));

    /* add this file to the list that should be removed during clean */
    Pkg.generatedFiles.$add(archiveName + ".cmd");

    /* put archiver options in the file */
    file.write(tokens.shift() + '\n');

    /* replace $@ token with actual archive name */
    tokens.shift(); /* should be == $@ */
    file.write(archiveName + '\n');

    /* finally, put all objects to go into the archive */
    for (var i = 0; i < tokens.length; i++) {
        file.write(tokens[i] + '\n');
    }

    file.flush();

    return (cmd);
}
